private class SudokuCell : Gtk.DrawingArea
{
    public SudokuCell ()
    {
        can_focus = true;
    }

    public override void size_request (out Gtk.Requisition requisition)
    {
        requisition.width = 40;
        requisition.height = 40;
    }

    public override bool expose_event (Gdk.EventExpose event)
    {
        Cairo.Context c = Gdk.cairo_create (window);

        if (is_focus)
            c.set_source_rgb (1.0, 0.0, 0.0);
        else
            c.set_source_rgb (1.0, 1.0, 1.0);
        c.rectangle (0, 0, allocation.width, allocation.height);
        c.fill ();

        c.set_source_rgb (0.0, 0.0, 0.0);
        //c.draw_text (

        return false;
    }
}

public class SudokuView : Gtk.AspectFrame
{
    private SudokuGame game;
    private SudokuCell[,] cells;

    public SudokuView (SudokuGame game)
    {
        this.game = game;

        shadow_type = Gtk.ShadowType.NONE;
        
        /* Use an EventBox to be able to set background */
        var box = new Gtk.EventBox ();
        box.modify_bg (Gtk.StateType.NORMAL, box.style.black);
        add (box);
        box.show ();

        var table = new Gtk.Table (9, 9, true);
        table.row_spacing = 1;
        table.column_spacing = 1;
        table.set_row_spacing (2, 2);
        table.set_row_spacing (5, 2);
        table.set_col_spacing (2, 2);
        table.set_col_spacing (5, 2);
        table.border_width = 2;

        cells = new SudokuCell[9,9];
        for (int row = 0; row < 9; row++)
            for (int col = 0; col < 9; col++)
            {
                var cell = new SudokuCell ();
                cells[row, col] = cell;
                cell.show ();
                table.attach_defaults (cell, col, col+1, row, row+1);
            }
        box.add (table);
        table.show ();
    }
}
